//
// $Id: byte-sequence.cc 2 2007-12-30 09:48:00Z hat $
//
#include "byte-sequence.h"

ByteSequence::ByteSequence() { }
ByteSequence::ByteSequence(const ByteSequence& cb)
	: line_number(cb.line_number), bytes(cb.bytes) { }
ByteSequence& ByteSequence::operator=(const ByteSequence& cb)
{
	if(this != &cb) {
		line_number = cb.line_number; bytes = cb.bytes;
	}
	return *this;
}

ByteSequence::~ByteSequence() { }

void ByteSequence::set_line(int line) { line_number = line; }

int ByteSequence::get_line() { return line_number; }

void ByteSequence::add_byte(UINT32 byte)
{
	bytes.push_back(byte);
}

int ByteSequence::byte_length() { return bytes.size(); }

/** Copy the bytes to the output object \a pHelper.
 * @param max: If argument > 0, copy at most that many bytes
 */
void ByteSequence::copy_to_codehelper(CodeHelper& ch, int max)
{
	std::list<UINT32>::iterator iter;

	for(iter = bytes.begin(); iter != bytes.end(); ++iter) {
		ch.add_byte((*iter));
                if(max > 0) {
                    --max;
                    if(max == 0) return;
                }
	}
}

std::ostream& operator<<(std::ostream& os, const ByteSequence& bs)
{
	std::list<UINT32>::const_iterator iter;

	os << "[";
	for(iter = bs.bytes.begin(); iter != bs.bytes.end(); ++iter) {
		os << " " << *iter;
	}
	os << " ]"; return os;
}

