//
// $Id: byte-sequence.h 2 2007-12-30 09:48:00Z hat $
//
#ifndef H_BYTE_SEQUENCE
#define H_BYTE_SEQUENCE

#include "types.h"
#include <ostream>
#include "codehelper.h"

class ByteSequence;

std::ostream& operator<<(std::ostream& os, const ByteSequence& bs);

class ByteSequence
{
	friend std::ostream& operator<<(std::ostream& os,
	                                const ByteSequence& bs);
public:
	ByteSequence();
	ByteSequence(const ByteSequence& bs);
	ByteSequence& operator=(const ByteSequence&);
	~ByteSequence();

	void set_line(int line);
	void add_byte(UINT32 byte);

	int byte_length();
	int get_line();
	void copy_to_codehelper(CodeHelper&, int max=0);
protected:
	int line_number;
	list<UINT32> bytes;
};

#endif
