//
// $Id: codehelper.cc 2 2007-12-30 09:48:00Z hat $
//
#include <cassert>
#include "codehelper.h"

const static int iNumbytes = 20;

CodeHelper::CodeHelper(int sprnum, const string& sSprTxt)
    : sprite_number(sprnum), sSprName(sSprTxt) { }
CodeHelper::~CodeHelper() { }

void CodeHelper::add_byte(UINT32 val)
{
    char buffer[32];
    assert(val < 256);
    sprintf(buffer, "%02lX", val);
    cBytes.push_back(string(buffer));
}

void CodeHelper::add_word(UINT32 val)
{
    assert(val < 0x10000);
    add_byte(val&0xff); add_byte((val>>8) & 0xff);
}

void CodeHelper::add_double(UINT32 val)
{
    add_byte(val & 0xff); add_byte((val>>8) &  0xff);
    add_byte((val>>16) & 0xff); add_byte((val>>24) & 0xff);
}

void CodeHelper::add_extended(UINT32 val)
{
    if(val < 0xff)
        add_byte(val);
    else {
        add_byte(0xff); add_word(val);
    }
}

void CodeHelper::add_decimal(UINT32 val)
{
    char buffer[32];
    sprintf(buffer, "%lu", val);
    cBytes.push_back(string(buffer));
}
void CodeHelper::add_decimal(INT32 val)
{
    char buffer[32];
    sprintf(buffer, "%ld", val);
    cBytes.push_back(string(buffer));
}

void CodeHelper::output(FILE *fp)
{
    list<string>::iterator iter;

    fprintf(fp, "%d %s", sprite_number, sSprName.c_str());

    if(sSprName == string("*")) {
        /* Output length */
        fprintf(fp, " %d\t", cBytes.size());

        int count = 0;
        for(iter = cBytes.begin(); iter != cBytes.end(); ++iter) {
            if(count >= iNumbytes) {
                fprintf(fp, "\n\t"); count = 0;
            }
            fprintf(fp, " %s", (*iter).c_str()); ++count;
        }
    } else {
        for(iter = cBytes.begin(); iter != cBytes.end(); ++iter) {
            fprintf(fp, " %s", (*iter).c_str());
        }
    }
    fprintf(fp, "\n");
}

