//
// $Id: table.h 2 2007-12-30 09:48:00Z hat $
//
// Storage for read tables
//
#ifndef H_TABLE
#define H_TABLE

#include "types.h"

class TableEntry
{
public:
    TableEntry();
    TableEntry(const TableEntry& te);
    TableEntry& operator=(const TableEntry&);
    ~TableEntry();

    void reset();   //< Reset TableEntry to initial state

    int get_line() const;
    string get_name() const;
    UINT32 get_value() const;
    UINT32 get_size() const;
    UINT32 get_type() const;

    bool has_name() const;
    bool has_value() const;
    bool has_size() const;
    bool has_type() const;

    void set_line(int line);
    void set_name(const string& s);
    void set_value(UINT32 val);
    void set_size(UINT32 val);
    void set_type(UINT32 val);
protected:
    int iLine;
    bool bName, bValue, bSize, bType;

    string sName;
    UINT32 cValue;
    UINT32 cSize;
    UINT32 cType;
};

class Table
{
public:
    Table();
    Table(const Table& t);
    Table& operator=(const Table& t);
    ~Table();

    void add_entry(const TableEntry& te);
    void set_name(const string& s);

    string get_name() const;
    const TableEntry* get_entry(const string &sName) const;

protected:
    string sName;
    map<string, TableEntry> cEntries;
};

class Tables
{
public:
    Tables();
    ~Tables();

    void add_table(const Table& t);
    const Table *get_table(const string& sName) const;
protected:
    Table cDummy;
    map<string, Table> cTables;
};

extern Tables cTables;

#endif
