//
// $Id: yyfile.h 2 2007-12-30 09:48:00Z hat $
//
#ifndef H_YYFILE
#define H_YYFILE

#include <string>
#include <cstdio>
#include "generic-ast.h"

class MainNode;
class TableEntry;
class Table;

struct yytypestruct {
    int line;
    union {
        std::string *pString;
        TextString *pTextString;
        INT32 int32;
        UINT32 uint32;
        BaseField *pBField;
        GenericNode *pGNode;
        ByteSequence *pBytes;
        IdentifierSet *pIdenSet;
        TableEntry *pTableEntry;
        Table *pTable;
        LabelLineList *pLabelLines;
    };
};
#define YYSTYPE yytypestruct
extern YYSTYPE yylval;

int yylex();
MainNode *parse_file(int debug);

void lex_init(FILE *, int debug);
void yyerror(const char *);

#endif
